import json


class WorkOrder:

    def __init__(self, WorkItem_Type="DockerWorker", ImageName="ubuntu1804python3dtk", Command=None, **kwargs):
        self.WorkItem_Type = WorkItem_Type
        self.ImageName = ImageName
        self.Command = Command
        self.Additional = {}

        for key, value in kwargs.items():
            setattr(self, key, value)

    def add_wo(self, key, value):
        self.Additional[key] = value

    def wo_2_dict(self):
        wo_dict = self.__dict__
        wo_dict.update(self.Additional)
        wo_dict.pop('Additional')

        return wo_dict

    def wo_2_dict_str(self):
        wo_dict = self.wo_2_dict()
        wo_dict_str = json.dumps(wo_dict, default=lambda obj: '')

        return wo_dict_str.encode('utf-8')


def main():
    kwargs = {"A": "a", "B": "b"}
    wo = WorkOrder(**kwargs)

    wo.add_wo("Test", 10)

    print(wo.__dict__)

    print(wo.wo_2_dict())


if __name__ == "__main__":
    main()
